diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceablePair.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceablePair.java
index 0b2c38152..b3ca78b96 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceablePair.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceablePair.java
@@ -109,9 +109,9 @@ public abstract class ItemPlaceablePair extends Item implements IPlaceable {
         final boolean isAIdentical, isBIdentical;
 
         prevBlockA = world.getBlockType(posA);
-        prevDataA = world.getBlockData(posA);
-
         prevBlockB = world.getBlockType(posB);
+
+        prevDataA = world.getBlockData(posA);
         prevDataB = world.getBlockData(posB);
         
         isAIdentical = prevBlockA == this.blockA && prevDataA == dataA;
@@ -147,8 +147,8 @@ public abstract class ItemPlaceablePair extends Item implements IPlaceable {
         if (isAIdentical != isBIdentical) {
             if (isAIdentical) world.notifyBlocksOfNeighborChange(posB, this.blockB);
             else world.notifyBlocksOfNeighborChange(posA, this.blockA);
-        } else if (isAIdentical) {
-            assert isBIdentical;
+        } else if (!isAIdentical) {
+            assert !isBIdentical;
             world.notifyBlocksOfNeighborChanges(new TilePosc[] { posA, posB }, null);
         }
         world.playBlockSoundEffect(
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index 998e08a73..7cda51a62 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -369,27 +369,29 @@ public final class ItemStack {
     }
 
     public static boolean areItemStacksEqual(@Nullable ItemStack stack1, @Nullable ItemStack stack2) {
-        if(stack1 == null && stack2 == null) {
-            return true;
-        }
-        if(stack1 == null || stack2 == null) {
-            return false;
-        }
-        return stack1.isItemStackEqual(stack2);
+        if (stack1 == stack2) return true;
+        if (stack1 == null || stack2 == null) return false;
+        return stack1.stackSize == stack2.stackSize &&
+            stack1.itemID == stack2.itemID && stack1.metadata == stack2.metadata;
+    }
+    
+    public boolean isItemStackEqual(@NotNull ItemStack itemstack) {
+        if (this == itemstack) return true;
+        if (itemstack == null) return false;
+        return this.stackSize == itemstack.stackSize &&
+            this.itemID == itemstack.itemID && this.metadata == itemstack.metadata;
     }
 
-    private boolean isItemStackEqual(@NotNull ItemStack itemstack) {
-        if(this.stackSize != itemstack.stackSize) {
-            return false;
-        }
-        if(this.itemID != itemstack.itemID) {
-            return false;
-        }
-        return this.metadata == itemstack.metadata;
+    public static boolean areItemsEqual(@Nullable ItemStack stack1, @Nullable ItemStack stack2) {
+        if (stack1 == stack2) return true;
+        if (stack1 == null || stack2 == null) return false;
+        return stack1.itemID == stack2.itemID && stack1.metadata == stack2.metadata;
     }
 
     public boolean isItemEqual(@Nullable ItemStack itemstack) {
-        return itemstack != null && this.itemID == itemstack.itemID && this.metadata == itemstack.metadata;
+        if (this == itemstack) return true;
+        if (itemstack == null) return false;
+        return this.itemID == itemstack.itemID && this.metadata == itemstack.metadata;
     }
 
     public @NotNull String getItemKey() {
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index 4ba690e00..7c27f8209 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -27,14 +27,16 @@ public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
         final TilePos bp = new TilePos(blockPos);
         final @NotNull BlockLogicLadder ladder = this.block.getLogic();
 
-        final Side pside;
+        final @NotNull Side pside;
         if ((player != null && player.isSneaking()) || world.getBlockType(bp) != this.block) {
             if (super.shouldShiftOutOf(selfStack, world, player, bp, side, xHit, yHit)) bp.add(side.direction());
             pside = ladder.getSideForPlacement(world, bp, side);
+            if (pside == null) return false;
         } else {
             xHit = 0.5;
             yHit = 0.5;
             pside = ladder.getSideFromMeta(world.getBlockData(bp));
+            if (pside == Side.NONE) return false;
             while (world.getBlockType(bp) == this.block && ladder.getSideFromMeta(world.getBlockData(bp)) == pside) {
                 bp.down();
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index d69e43401..0e2a2d058 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -708,17 +708,12 @@ public abstract class World implements MutableWorldSource {
     }
 
     public boolean setBlockDataNotify(final @NotNull TilePosc tilePos, final int data) {
-        if (this.setBlockData(tilePos, data)) {
-            this.markBlockNeedsUpdate(tilePos);
-
-            final @NotNull Block<?> block = this.getBlockType(tilePos);
-            if (block.neighborNotifyOnDataChangeDisabled()) {
-                this.notifyBlocksOfNeighborChange(tilePos, block);
-                return true;
-            }
-        }
+        if (!this.setBlockData(tilePos, data)) return false;
+        this.markBlockNeedsUpdate(tilePos);
 
-        return false;
+        final @NotNull Block<?> block = this.getBlockType(tilePos);
+        this.notifyBlocksOfNeighborChange(tilePos, block);
+        return true;
     }
 
     @Deprecated
